#include "Behavioural/Generic/Queue_Control/include/Queue_Control.h"

namespace morpheo {
namespace behavioural {
namespace generic {
namespace queue_control {

#undef  FUNCTION
#define FUNCTION "Queue_Control::push"
  uint32_t Queue_Control::push (void)
  {
    log_printf(FUNC,Queue_Control,FUNCTION,"Begin");

    uint32_t _return = (*_tab)[_nb_elt];
    _nb_elt ++;
	
    log_printf(FUNC,Queue_Control,FUNCTION,"End");

    return _return;
  };

#undef  FUNCTION
#define FUNCTION "Queue_Control::push_ovf"
  uint32_t Queue_Control::push_ovf (void)
  {
    log_printf(FUNC,Queue_Control,FUNCTION,"Begin");

    if (full())
      {
	ErrorMorpheo ("<Queue_Control::push_ovf> Queue Overflow");
      }

    uint32_t _return = push();
	
    log_printf(FUNC,Queue_Control,FUNCTION,"End");

    return _return;
  };

}; // end namespace queue_control
}; // end namespace generic
}; // end namespace behavioural
}; // end namespace morpheo              
